#include <USB recepcion.h>

#include "stdlib.h"

#FUSES NOMCLR

#define USB_CDC_ISR() recibe() //Interrupcion por recepcion de datos

void recibe();//Subrutina de la interrupcion

#define USB_CONFIG_BUS_POWER 500 //500ma corriente de entrada

#include "usb_cdc.h"

char recibido[15];

int8 val01_num = 0;
int8 val02_num = 0;

void datos();

void recibe()
{
   memset(recibido, 0, sizeof(recibido)); //limpia los registros de la varible
   int8 i=0;
   while(true)
   {
      recibido[i] = usb_cdc_getc();//RECIBE EL CARACTER

      if(recibido[i] == '\n')//busca el salto de linea \r
      {
         recibido[i-1] = '\0';  //  \r = \0 (caracter nulo)
         recibido[i] = '\0';   //  \n = \0 (caracter nulo)

         datos();
         return;
      }
      i++;
   }
}

void datos()
{
   signed int8 result;

   char ID_val[6];
   char num[4];

   char val01[6] = "val01";
   char val02[6] = "val02";

   memset(ID_val, 0, sizeof(ID_val)); //limpia los registros de la varible ID_val
   memset(num, 0, sizeof(num)); //limpia los registros de la varible num

       for (int i=0; i<=4; ++i)
      {
         ID_val[i] = recibido[i]; //identifica la variable
      }

      for (int i=0; i<=2; ++i)
      {
         num[i] = recibido[i+5]; //guarda el valor de la variable
      }

      result = strcmp(ID_val, val01);//compara, si son iguales (0), no (+-1)

      if(result==0)
      {
         val01_num = (int8)atoi(num);  //convierte la cadena en un numero de 8bits
         return;
      }

      result = strcmp(ID_val, val02);

      if(result==0)
      {
         val02_num = (int8)atoi(num); //convierte la cadena en un numero de 8bits
         return;
      }
}

void main()
{
   usb_init(); 
   
   setup_timer_2(T2_DIV_BY_16,63,1);

   setup_ccp1(CCP_PWM);//habilita el pin ccp1
   setup_ccp2(CCP_PWM);//habilita el pin ccp2
   
   while(TRUE)
   {
      set_pwm1_duty((int16)val01_num);//100% duty clicle = numero 255
      set_pwm2_duty((int16)val02_num);

      //TODO: User Code
   }

}
